VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSymbols"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Copyright 2005
'dzzie@yahoo.com
'http://sandsprite.com

Dim pe As New CPEEditor
Dim match As New CMatchedCollection

Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Sub LoadSymbols(dllPath As String)
    
    If NOSYMBOLS Then Exit Sub 'they do take allot of time to load :(
    
    Dim fullPath As String
    
    fullPath = dllPath
    If Not FileExists(fullPath) Then
        fullPath = Environ("WinDir") & "\" & dllPath
        If Not FileExists(fullPath) Then
            fullPath = Environ("WinDir") & "\System32\" & dllPath
            If Not FileExists(fullPath) Then
                Debug.Print "CSymbols could not find: " & dllPath
                Exit Sub
            End If
        End If
    End If
    
    If Not pe.LoadFile(fullPath) Then
        Debug.Print "CSymbols.CPEEditor failed to load: " & dllPath
        Exit Sub
    End If
    
    Dim f As CExport
    Dim h As Long
    
    On Error Resume Next
        
    h = GetModuleHandle(dllPath)
        
    Dim adr As Long
    Dim name As String
    
    For Each f In pe.Exports.functions
        name = IIf(Len(f.FunctionName) > 0, f.FunctionName, f.FunctionOrdial)
        adr = GetProcAddress(h, name)
        If adr > 0 Then
            'Replace(LCase(dllPath), ".dll", "") & "!" &
            match.addElement adr, name, f.FunctionAddress
        End If
    Next
        
End Sub

Function GetSymbol(va As Long) As String
    If match.KeyExists(va) Then
        GetSymbol = match.GetValueByKey(va)
    End If
End Function

Sub Clear()
    match.Clear
End Sub

Function GetSymbolForAsm(asm As String) As String
    Dim va As Long
    
    On Error Resume Next
    'there is ALLOT more decoding we could do here to recgonize addresses!
    'not to mention decoding known function prototypes and commenting asm!!
    'man thats allot of work...

    If InStr(asm, "CALL") > 0 Then
        If InStr(asm, "[") > 0 Then
            va = GetAddressFromPointer(asm)
            GetSymbolForAsm = Me.GetSymbol(va)
        Else
            'if this next line fails its not numeric..must be register CALL EAX
            va = CLng("&h" & Mid(asm, InStr(asm, "CALL") + 5))
            GetSymbolForAsm = Me.GetSymbol(va)
        End If
    ElseIf InStr(asm, "JMP") > 0 Then
        If InStr(asm, "[") > 0 Then
            va = GetAddressFromPointer(asm)
            GetSymbolForAsm = Me.GetSymbol(va)
        Else
            'if this next line fails its not numeric..must be register JMP EAX
            va = CLng("&h" & Mid(asm, InStr(asm, "JMP") + 4))
            GetSymbolForAsm = Me.GetSymbol(va)
        End If
    End If
    
End Function

Private Function GetAddressFromPointer(cmd As String) As Long
    Dim tmp As String
    Dim s As Long
    Dim e As Long
    Dim adr As Long
    
    On Error GoTo hell
    s = InStr(cmd, "[")
    e = InStr(s, cmd, "]")
    
    'if this next line fails its not numeric..must be register CALL [EAX]
    adr = CLng("&h" & Mid(cmd, s + 1, e - s - 1))
    adr = ReadLng(adr)
    GetAddressFromPointer = adr
hell:
    
End Function
