VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H8000000A&
   Caption         =   "vb_dbg  -  http://sandsprite.com"
   ClientHeight    =   7545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11925
   LinkTopic       =   "Form1"
   ScaleHeight     =   7545
   ScaleWidth      =   11925
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pictMem 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2235
      Left            =   0
      ScaleHeight     =   2235
      ScaleWidth      =   9375
      TabIndex        =   5
      Top             =   3660
      Width           =   9375
   End
   Begin VB.TextBox Text1 
      Appearance      =   0  'Flat
      Height          =   1275
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      Top             =   5940
      Width           =   9375
   End
   Begin VB.PictureBox pictStack 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3555
      Left            =   9480
      ScaleHeight     =   3555
      ScaleWidth      =   2415
      TabIndex        =   3
      Top             =   3660
      Width           =   2415
   End
   Begin VB.TextBox txtCommand 
      Appearance      =   0  'Flat
      BackColor       =   &H00E0E0E0&
      BeginProperty Font 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   285
      Left            =   0
      TabIndex        =   2
      Top             =   7260
      Width           =   11895
   End
   Begin VB.PictureBox pictDisasm 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3615
      Left            =   0
      ScaleHeight     =   3615
      ScaleWidth      =   9375
      TabIndex        =   1
      Top             =   0
      Width           =   9375
   End
   Begin VB.PictureBox pictRegBox 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3615
      Left            =   9480
      ScaleHeight     =   3615
      ScaleWidth      =   2415
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
   Begin VB.Line Line1 
      BorderWidth     =   3
      X1              =   13440
      X2              =   0
      Y1              =   3660
      Y2              =   3660
   End
   Begin VB.Line Line2 
      BorderWidth     =   2
      X1              =   9420
      X2              =   9420
      Y1              =   7260
      Y2              =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Copyright 2005
'dzzie@yahoo.com
'http://sandsprite.com

'Sandsprite.com VB Debugger Example
'
'This is a bare bones debugger written in VB/C
'To launch or attach the debugged process we call out from our vb ui
'to a C dll I made that does so in a seperate thread. When a debug event
'or exception occurs, this thread will use interprocess communication
'methods to notify the main (single threaded) VB UI.
'
'The interprocess commun method i chose was to subclass the main form
'looking for the WM_COPYDATA message and transferring the debug event
'info along with its data structure. Since VB only supports single threading
'threads spawned in non native dlls calling back into vb code will = crash
'
'disassembler functionality provided by olly.dll which
'is a modified version of the GPL source from Oleh Yuschuk.
'Copyright (C) 2001, see CDisassembler for more details.
'
'Some structure definitions were taken from another VB debugger available here:
'http://www.Planet-Source-Code.com/vb/scripts/ShowCode.asp?txtCodeId=42422&lngWId=1
'
'External Dependancies:
'   1) olly.dll       - disassembler - VC6 - open source
'   2) vb_dbg.dll     - debugger/thread controller VC6 - open source
'   3) spSubclass.dll - subclass component VB6 (ActiveX must regsvr32) - closed source
'   4) peview.dll     - pe viewer classes VB6 (ActiveX must regsvr32) - dll project source
'                         not available  but classes are available on site in
'                         pecrypter project
'
'License: You are free to use any of the code I developed in this project in anyway
'         you need without restriction however you cannot remove any copyright notices.
'
'         Olly.dll is subject to its own licensing terms as it uses 3rd party code
'         please refer to the project homepage and source package for further details.
'
'           http://sandsprite.com/CodeStuff/olly_dll.html







Private Sub Form_Load()
    LoadEvents
    dbg.Initilize Me.hwnd
    Set cache.Display = pictDisasm
    Set cache.RegBox = pictRegBox
    Set cache.Stack = pictStack
    Set cache.Memory = pictMem
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If ActivePID > 0 Then dbg.StopDbg
End Sub

Private Sub txtCommand_KeyDown(KeyCode As Integer, Shift As Integer)
    
    'single key commands
    Select Case KeyCode
        Case 46: txtCommand = Empty         'delete key = clear
        Case 118: tm.SetSingleStep: dbg.Run 'F7 single step
        Case 119: cache.StepOver            'F8 step over
        Case 116: dbg.Run                   'F5 run
    End Select
    
    
    If KeyCode <> 13 Then Exit Sub 'return key = process string command
        
    Dim x() As String
    x = Split(Trim(txtCommand), " ")
    
    On Error GoTo hell
    
    Select Case UCase(x(0))
        Case "ATTACH": dbg.Attach CLng(x(1))
        Case "STOP": dbg.StopDbg
        Case "END": dbg.StopDbg: Unload Me
        Case "LOAD": dbg.LaunchProcess x(1)
        Case "RUN": dbg.Run
        Case "STEP", "S": tm.SetSingleStep: dbg.Run
        Case "STEPOVER", "SO", "O": cache.StepOver
        Case "BPX", "BP": bpm.AddBreakPoint CLng("&h" & x(1))
        Case "GO": bpm.AddBreakPoint CLng("&h" & x(1)): dbg.Run
        Case "BC": bpm.RemoveBreakPoint CLng("&h" & x(1))
        Case "BL": Additem Join(bpm.GetList, vbCrLf), True
        Case "REFRESH": cache.Refresh
        Case "POKEB": dbg.PokeB CLng("&h" & x(1)), CByte("&h" & x(2)): cache.Refresh
        Case "POKEL": dbg.PokeL CLng("&h" & x(1)), CLng("&h" & x(2)): cache.Refresh
        Case "CLEAR", "CLS": Text1 = Empty
        Case "EIP": cache.ModifyRegister Eip, CLng("&h" & x(1))
        Case "EAX": cache.ModifyRegister Eax, CLng("&h" & x(1))
        Case "EBX":  cache.ModifyRegister Ebx, CLng("&h" & x(1))
        Case "ECX":  cache.ModifyRegister Ecx, CLng("&h" & x(1))
        Case "EDX":  cache.ModifyRegister Edx, CLng("&h" & x(1))
        Case "PAUSE", "BREAK": tm.PauseAll
        Case "RESUME": tm.ResumeAll
        Case "MODS": Additem Join(mm.GetList, vbCrLf), True
        Case "MEM": cache.DumpMemory CLng("&h" & x(1))
        Case "HELP": MsgBox "No help help yet sorry..view form1 source and comments.", vbExclamation
    
        'Case "HWBPX": bpm.HardwareBPX CLng(x(1)), DBG_COND_EXECUTE
        ' Case "HWBPR":  cache.HardwareBPX CLng(x(1)), DBG_COND_READWRITE
        ' Case "HWBP": cache.HardwareBPX CLng(x(1)), DBG_COND_READWRITE
        ' Case "HWBL": cache.RemoveHardwareBPX CLng(x(1))
      
        Case Else: MsgBox "Unknown Cmd:" & x(0)
    End Select
        
    Exit Sub
hell: MsgBox "Error: " & Err.Description, vbInformation
           
End Sub


                        
 
