VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CThreadManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Copyright 2005
'dzzie@yahoo.com
'http://sandsprite.com

Private match As New CMatchedCollection

Public ActiveThreadID As Long 'set in main debug loop each time triggered

Private Sub Class_Initialize()
    'threadids and handles will both be unique, full power of class ok
    match.ValuesMustBeUnique = True
End Sub

Sub AddThread(id, handle, Optional start)
    match.addElement id, handle, start
End Sub

Sub RemoveThread(id)
    match.RemoveByKey id
End Sub

Function GetThreadHandle(id)
    GetThreadHandle = match.GetValueByKey(id)
End Function

Function GetThreadID(handle)
    GetThreadID = match.GetKeyByValue(handle)
End Function

Function GetThreadStart(id)
    GetThreadStart = match.GetTagByKey(id)
End Function

Sub Clear()
    match.Clear
End Sub

Function GetList() As Long()
    Dim tmp() As Long, f
    For Each f In match.Keys
        push tmp, CLng(f.key)
    Next
    GetList = tmp
End Function

Sub PauseAll()
    Dim f
    For Each f In match.Keys: SuspendThread CLng(f.value):   Next
End Sub

Sub ResumeAll()
   Dim f
   For Each f In match.Keys: ResumeThread CLng(f.value):  Next
End Sub

Sub SetSingleStep()
    Dim ctx As CONTEXT
    ctx = GetContext(ActiveThreadID)
    ctx.EFlags = ctx.EFlags Or &H100&
    SetContext ActiveThreadID, ctx
End Sub

Sub ClearSingleStep()
    Dim ctx As CONTEXT
    ctx = GetContext(ActiveThreadID)
    If (ctx.EFlags And &H100&) = &H100& Then ctx.EFlags = ctx.EFlags Xor &H100&
    SetContext ActiveThreadID, ctx
End Sub

